#include	<stdlib.h>
#include	<string.h>

#include	<yz/draw.h>

#include	"button.h"
#include	"private.h"

void	yzDrawButton(button_t	*b)
{
	int	textx;
	int	x1, y1, x2, y2;
	
	yzPushClipRect(b->x, b->y, b->x+b->dx-1, b->y+b->dy-1);
	yzSelectFont(b->font?b->font:"system");
	textx = b->x + (b->dx/2) - yzStringSize(b->name, strlen(b->name))/2 -1;
	x1 = b->x; y1 = b->y;
	x2 = b->x + b->dx-1; y2 = b->y + b->dy-1;
	
	switch(b->state)
	{
		case	0:	//not pressed
			yzPenColor(20000, 20000, 20000);
			yzOutlineRect(x1, y1, x2, y2);	x1++;y1++;x2--;y2--;
			yzPenColor(30000, 30000, 30000);
			yzOutlineRect(x1, y1, x2, y2);	x1++;y1++;x2--;y2--;
			yzPenColor(35000, 35000, 35000);
			yzOutlineRect(x1, y1, x2, y2);	x2--;y2--;
			yzPenColor(40000, 40000, 40000);
			yzOutlineRect(x1, y1, x2, y2);	x1++;y1++;x2--;y2--;
			yzPenColor(45000, 45000, 50000);
			yzOutlineRect(x1, y1, x2, y2);	x1++;y1++;x2--;y2--;
			yzPenColor(50000, 50000, 50500);
			yzOutlineRect(x1, y1, x2, y2);	x2--;y2--;
			
			yzPenColor(53000, 53000, 51000);
			yzRect(x1, y1, x2, y2);
			yzPenColor(0, 0, 0);
			yzText(textx, b->y + b->dy/2 + 4, b->name);
			break;
		case	1:	//pressed
			yzPenColor(10000, 10000, 10000);
			yzOutlineRect(x1, y1, x2, y2);	x1++;y1++;x2--;y2--;
			yzPenColor(20000, 20000, 20000);
			yzOutlineRect(x1, y1, x2, y2);	x1++;y1++;x2--;y2--;
			yzPenColor(25000, 25000, 25000);
			yzOutlineRect(x1, y1, x2, y2);	x1++;y1++;
			yzPenColor(30000, 30000, 30000);
			yzOutlineRect(x1, y1, x2, y2);	x1++;y1++;x2--;y2--;
			yzPenColor(35000, 35000, 40000);
			yzOutlineRect(x1, y1, x2, y2);	x1++;y1++;x2--;y2--;
			yzPenColor(37500, 37500, 40000);
			yzOutlineRect(x1, y1, x2, y2);	x1++;y1++;
			
			yzPenColor(40000, 40000, 45000);
			yzRect(x1, y1, x2, y2);
			yzPenColor(65535, 65535, 65535);
			yzText(textx+1, 1+b->y + b->dy/2 + 4, b->name);
			break;
	}
	yzPenColor(0, 0, 0);
	yzOutlineRect(b->x, b->y, b->x+b->dx-1, b->y+b->dy-1);
	yzPopClipRect();
}

int	point_in_button(int	x, int	y, button_t	*b)
{
	if(x<b->x || x>(b->x+b->dx-1) || y<b->y || y>(b->y+b->dy-1))return 0;
	else return 1;
}
